<?php
namespace Bushelpowered\Api\Aggregator\Crm\V1\Response;
        
class CustomerAddressResponse 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $addressType The customer's address type. Home, work, etc.*/
    public string $addressType;
    /** @var string $line1 The customer's street address, line 1*/
    public string $line1;
    /** @var string $city The customer's address city*/
    public string $city;
    /** @var string $state The customer's address state, 2 character abbreviation*/
    public string $state;
    /** @var string $zip The customer's address zip code, 10 character limit*/
    public string $zip;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $addressType The customer's address type. Home, work, etc.
     * @param  string  $line1 The customer's street address, line 1
     * @param  string  $city The customer's address city
     * @param  string  $state The customer's address state, 2 character abbreviation
     * @param  string  $zip The customer's address zip code, 10 character limit
     */
    public function __construct(string $id, string $addressType, string $line1, string $city, string $state, string $zip)
    {
        $this->id = $id;
        $this->addressType = $addressType;
        $this->line1 = $line1;
        $this->city = $city;
        $this->state = $state;
        $this->zip = $zip;
    }
    

}