<?php
namespace Bushelpowered\Api\Aggregator\Payments\V1\Request;
        
class CreateRainforestPaymentMethodConfigRequest 
{
    /** @var string $cardholderName The persons name that is on the card*/
    public string $cardholderName;
    /** @var string $email The email that will get associated with the card*/
    public string $email;
    /** @var string $addressLine1 The address that is on the card*/
    public string $addressLine1;
    /** @var null|string $addressLine2 The address that is on the card*/
    public ?string $addressLine2 = null;
    /** @var string $city The city that is on the card*/
    public string $city;
    /** @var string $state The state that is on the card*/
    public string $state;
    /** @var string $zipCode The zip code that is on the card*/
    public string $zipCode;

    /**
     * @param  string  $cardholderName The persons name that is on the card
     * @param  string  $email The email that will get associated with the card
     * @param  string  $addressLine1 The address that is on the card
     * @param  null|string  $addressLine2 The address that is on the card
     * @param  string  $city The city that is on the card
     * @param  string  $state The state that is on the card
     * @param  string  $zipCode The zip code that is on the card
     */
    public function __construct(string $cardholderName, string $email, string $addressLine1, ?string $addressLine2, string $city, string $state, string $zipCode)
    {
        $this->cardholderName = $cardholderName;
        $this->email = $email;
        $this->addressLine1 = $addressLine1;
        $this->addressLine2 = $addressLine2;
        $this->city = $city;
        $this->state = $state;
        $this->zipCode = $zipCode;
    }
    

}