<?php
namespace Bushelpowered\Api\Crm\V1\Request;
        
class CustomersFilters implements \Bushelpowered\Api\Common\HasCreatedAtFilter
{
    /** @var string[]|null $ids Customer id in list*/
    public ?array $ids = null;
    /** @var string[]|null $tenantIds Tenant id in list*/
    public ?array $tenantIds = null;
    /** @var null|float $demographicTotalStorageCapacityEqualOrGreater Total on-farm storage capacity is greater than or equal to*/
    public ?float $demographicTotalStorageCapacityEqualOrGreater = null;
    /** @var null|float $demographicTotalStorageCapacityLess Total on-farm storage capacity is less than */
    public ?float $demographicTotalStorageCapacityLess = null;
    /** @var null|float $demographicTotalAreaEqualOrGreater Total number of land units is greater than or equal to*/
    public ?float $demographicTotalAreaEqualOrGreater = null;
    /** @var null|float $demographicTotalAreaLess Total number of land units is less than*/
    public ?float $demographicTotalAreaLess = null;
    /** @var string[]|null $demographicCommoditySubgroups Demographic commodity subgroup in list*/
    public ?array $demographicCommoditySubgroups = null;
    /** @var string[]|null $assignedToStaffUsers Staff user id in list*/
    public ?array $assignedToStaffUsers = null;
    /** @var null|string $latestActivityEqualOrAfter Latest activity is equal or after of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $latestActivityEqualOrAfter = null;
    /** @var null|string $latestActivityAtBefore Latest activity is before of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $latestActivityAtBefore = null;
    /** @var null|string $createdAtEqualOrAfter Created at is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $createdAtEqualOrAfter = null;
    /** @var null|string $createdAtBefore Created at is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $createdAtBefore = null;

    /**
     * @param  string[]|null  $ids Customer id in list
     * @param  string[]|null  $tenantIds Tenant id in list
     * @param  null|float  $demographicTotalStorageCapacityEqualOrGreater Total on-farm storage capacity is greater than or equal to
     * @param  null|float  $demographicTotalStorageCapacityLess Total on-farm storage capacity is less than 
     * @param  null|float  $demographicTotalAreaEqualOrGreater Total number of land units is greater than or equal to
     * @param  null|float  $demographicTotalAreaLess Total number of land units is less than
     * @param  string[]|null  $demographicCommoditySubgroups Demographic commodity subgroup in list
     * @param  string[]|null  $assignedToStaffUsers Staff user id in list
     * @param  null|string  $latestActivityEqualOrAfter Latest activity is equal or after of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $latestActivityAtBefore Latest activity is before of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $createdAtEqualOrAfter Created at is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $createdAtBefore Created at is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(?array $ids, ?array $tenantIds, ?float $demographicTotalStorageCapacityEqualOrGreater, ?float $demographicTotalStorageCapacityLess, ?float $demographicTotalAreaEqualOrGreater, ?float $demographicTotalAreaLess, ?array $demographicCommoditySubgroups, ?array $assignedToStaffUsers, ?string $latestActivityEqualOrAfter, ?string $latestActivityAtBefore, ?string $createdAtEqualOrAfter, ?string $createdAtBefore)
    {
        $this->ids = $ids;
        $this->tenantIds = $tenantIds;
        $this->demographicTotalStorageCapacityEqualOrGreater = $demographicTotalStorageCapacityEqualOrGreater;
        $this->demographicTotalStorageCapacityLess = $demographicTotalStorageCapacityLess;
        $this->demographicTotalAreaEqualOrGreater = $demographicTotalAreaEqualOrGreater;
        $this->demographicTotalAreaLess = $demographicTotalAreaLess;
        $this->demographicCommoditySubgroups = $demographicCommoditySubgroups;
        $this->assignedToStaffUsers = $assignedToStaffUsers;
        $this->latestActivityEqualOrAfter = $latestActivityEqualOrAfter;
        $this->latestActivityAtBefore = $latestActivityAtBefore;
        $this->createdAtEqualOrAfter = $createdAtEqualOrAfter;
        $this->createdAtBefore = $createdAtBefore;
    }
    
    /**
     * @return null|string Created at is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAtEqualOrAfter(): ?string
    {
        return $this->createdAtEqualOrAfter;
    }
    /**
     * @return null|string Created at is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAtBefore(): ?string
    {
        return $this->createdAtBefore;
    }
}