<?php
namespace Bushelpowered\Api\Crm\V1\Request;
        
class GetAllCustomersRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var null|string $search Search by name, phone, or email*/
    public ?string $search = null;
    /** @var null|\Bushelpowered\Api\Crm\V1\Request\CustomersFilters $filters */
    public ?\Bushelpowered\Api\Crm\V1\Request\CustomersFilters $filters = null;
    /** @var null|\Bushelpowered\Api\Crm\V1\Request\CustomerPagination $pagination */
    public ?\Bushelpowered\Api\Crm\V1\Request\CustomerPagination $pagination = null;

    /**
     * @param  null|string  $search Search by name, phone, or email
     * @param  null|\Bushelpowered\Api\Crm\V1\Request\CustomersFilters  $filters 
     * @param  null|\Bushelpowered\Api\Crm\V1\Request\CustomerPagination  $pagination 
     */
    public function __construct(?string $search, ?\Bushelpowered\Api\Crm\V1\Request\CustomersFilters $filters, ?\Bushelpowered\Api\Crm\V1\Request\CustomerPagination $pagination)
    {
        $this->search = $search;
        $this->filters = $filters;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Crm\V1\Request\CustomerPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Crm\V1\Request\CustomerPagination
    {
        return $this->pagination;
    }
}