<?php
namespace Bushelpowered\Api\Fulfillment\Contract\V1\Response;
        
class ContractDetailResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id The id of the contract*/
    public string $id;
    /** @var string $remoteId The id of contract in the remote system*/
    public string $remoteId;
    /** @var null|string $displayId The display id of contract*/
    public ?string $displayId = null;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $contractedLocation */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $contractedLocation;
    /** @var null|float $quantityContracted */
    public ?float $quantityContracted = null;
    /** @var null|float $quantityRemaining */
    public ?float $quantityRemaining = null;
    /** @var null|float $quantityCanceled */
    public ?float $quantityCanceled = null;
    /** @var null|float $quantityPriced */
    public ?float $quantityPriced = null;
    /** @var null|float $quantityUnpriced */
    public ?float $quantityUnpriced = null;
    /** @var null|string $quantityUom */
    public ?string $quantityUom = null;
    /** @var string $contractType */
    public string $contractType;
    /** @var string $status */
    public string $status;
    /** @var null|string $signatureStatus */
    public ?string $signatureStatus = null;
    /** @var null|float $pricing The price of the contract. If null it is considered 'unpriced'*/
    public ?float $pricing = null;
    /** @var null|string $cropYear */
    public ?string $cropYear = null;
    /** @var \Bushelpowered\Api\Fulfillment\Contract\V1\Response\PricingLineResponse[] $pricingLines */
    public array $pricingLines;
    /** @var null|string $remoteCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteCreatedAt = null;
    /** @var null|string $remoteUpdatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteUpdatedAt = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id The id of the contract
     * @param  string  $remoteId The id of contract in the remote system
     * @param  null|string  $displayId The display id of contract
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse  $account 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse  $company 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse  $commodity 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse  $contractedLocation 
     * @param  null|float  $quantityContracted 
     * @param  null|float  $quantityRemaining 
     * @param  null|float  $quantityCanceled 
     * @param  null|float  $quantityPriced 
     * @param  null|float  $quantityUnpriced 
     * @param  null|string  $quantityUom 
     * @param  string  $contractType 
     * @param  string  $status 
     * @param  null|string  $signatureStatus 
     * @param  null|float  $pricing The price of the contract. If null it is considered 'unpriced'
     * @param  null|string  $cropYear 
     * @param  \Bushelpowered\Api\Fulfillment\Contract\V1\Response\PricingLineResponse[]  $pricingLines 
     * @param  null|string  $remoteCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $remoteUpdatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $remoteId, ?string $displayId, \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $contractedLocation, ?float $quantityContracted, ?float $quantityRemaining, ?float $quantityCanceled, ?float $quantityPriced, ?float $quantityUnpriced, ?string $quantityUom, string $contractType, string $status, ?string $signatureStatus, ?float $pricing, ?string $cropYear, array $pricingLines, ?string $remoteCreatedAt, ?string $remoteUpdatedAt, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->account = $account;
        $this->company = $company;
        $this->commodity = $commodity;
        $this->contractedLocation = $contractedLocation;
        $this->quantityContracted = $quantityContracted;
        $this->quantityRemaining = $quantityRemaining;
        $this->quantityCanceled = $quantityCanceled;
        $this->quantityPriced = $quantityPriced;
        $this->quantityUnpriced = $quantityUnpriced;
        $this->quantityUom = $quantityUom;
        $this->contractType = $contractType;
        $this->status = $status;
        $this->signatureStatus = $signatureStatus;
        $this->pricing = $pricing;
        $this->cropYear = $cropYear;
        $this->pricingLines = $pricingLines;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}