<?php
namespace Bushelpowered\Api\Fulfillment\Recipient\V1\Response;
        
class RecipientDetailResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id */
    public string $id;
    /** @var string $name The name of the recipient*/
    public string $name;
    /** @var string $email The email address to send to*/
    public string $email;
    /** @var string $phoneNumber The phone number to send to*/
    public string $phoneNumber;
    /** @var bool $enableEmail Whether or not the notification will be sent via email*/
    public bool $enableEmail;
    /** @var bool $enablePhoneNumber Whether or not the notification will be sent via phone number*/
    public bool $enablePhoneNumber;
    /** @var \Bushelpowered\Api\Fulfillment\Threshold\V1\Response\ThresholdResponse[] $thresholds The Thresholds that this Recipient is attached to.*/
    public array $thresholds;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id 
     * @param  string  $name The name of the recipient
     * @param  string  $email The email address to send to
     * @param  string  $phoneNumber The phone number to send to
     * @param  bool  $enableEmail Whether or not the notification will be sent via email
     * @param  bool  $enablePhoneNumber Whether or not the notification will be sent via phone number
     * @param  \Bushelpowered\Api\Fulfillment\Threshold\V1\Response\ThresholdResponse[]  $thresholds The Thresholds that this Recipient is attached to.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $name, string $email, string $phoneNumber, bool $enableEmail, bool $enablePhoneNumber, array $thresholds, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->name = $name;
        $this->email = $email;
        $this->phoneNumber = $phoneNumber;
        $this->enableEmail = $enableEmail;
        $this->enablePhoneNumber = $enablePhoneNumber;
        $this->thresholds = $thresholds;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}