<?php
namespace Bushelpowered\Api\Iam\Serviceaccounts\V1;

use \Bushelpowered\Api\Iam\Serviceaccounts\V1\Request\GetAllServiceAccountKeysRequest;
use \Bushelpowered\Api\Iam\Serviceaccounts\V1\Response\GetAllServiceAccountKeysResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetAllServiceAccountKeys 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(GetAllServiceAccountKeysRequest $request, $headers): GetAllServiceAccountKeysResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/iam/serviceaccounts/v1/GetAllServiceAccountKeys', $request, $this->getWrapper(), $headers);
    }
    
    public function request(GetAllServiceAccountKeysRequest $request, GetAllServiceAccountKeysMetadata $hasHeaders): GetAllServiceAccountKeysResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/iam/serviceaccounts/v1/GetAllServiceAccountKeys', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetAllServiceAccountKeysResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.iam.serviceaccounts.v1#GetAllServiceAccountKeysSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Serviceaccounts\V1\Response\GetAllServiceAccountKeysResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}