<?php
namespace Bushelpowered\Api\Platform\Eventstore\V1\Request;
        
class GetEventsRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var string $stream The name of the stream*/
    public string $stream;
    /** @var null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\CompactedBy $compactedBy */
    public ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\CompactedBy $compactedBy = null;
    /** @var null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventFilter $filter */
    public ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventFilter $filter = null;
    /** @var null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventPagination $pagination */
    public ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventPagination $pagination = null;

    /**
     * @param  string  $stream The name of the stream
     * @param  null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\CompactedBy  $compactedBy 
     * @param  null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventFilter  $filter 
     * @param  null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventPagination  $pagination 
     */
    public function __construct(string $stream, ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\CompactedBy $compactedBy, ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventFilter $filter, ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventPagination $pagination)
    {
        $this->stream = $stream;
        $this->compactedBy = $compactedBy;
        $this->filter = $filter;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Platform\Eventstore\V1\Common\EventPagination
    {
        return $this->pagination;
    }
}