<?php

namespace Bushelpowered\Api\Platform\File\V1\Common;

class Attachment
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'discountSchedule' => '\Bushelpowered\Api\Platform\File\V1\Common\DiscountScheduleAttachment',
        'staffProfile' => '\Bushelpowered\Api\Platform\File\V1\Common\StaffProfileAttachment',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function DiscountSchedule(\Bushelpowered\Api\Platform\File\V1\Common\DiscountScheduleAttachment $data): Attachment
    {
        return new Attachment('discountSchedule', $data);
    }
    public static function StaffProfile(\Bushelpowered\Api\Platform\File\V1\Common\StaffProfileAttachment $data): Attachment
    {
        return new Attachment('staffProfile', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    