<?php
namespace Bushelpowered\Api\Platform\File\V1\Request;
        
class GetFilesRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var \Bushelpowered\Api\Platform\File\V1\Common\FileFilter[]|null $filters A list of filters.*/
    public ?array $filters = null;
    /** @var null|\Bushelpowered\Api\Platform\File\V1\Common\FilePagination $pagination */
    public ?\Bushelpowered\Api\Platform\File\V1\Common\FilePagination $pagination = null;
    /** @var \Bushelpowered\Api\Platform\File\V1\Request\GetFilesRequestOptions[]|null $options Options that control the response.*/
    public ?array $options = null;

    /**
     * @param  \Bushelpowered\Api\Platform\File\V1\Common\FileFilter[]|null  $filters A list of filters.
     * @param  null|\Bushelpowered\Api\Platform\File\V1\Common\FilePagination  $pagination 
     * @param  \Bushelpowered\Api\Platform\File\V1\Request\GetFilesRequestOptions[]|null  $options Options that control the response.
     */
    public function __construct(?array $filters, ?\Bushelpowered\Api\Platform\File\V1\Common\FilePagination $pagination, ?array $options)
    {
        $this->filters = $filters;
        $this->pagination = $pagination;
        $this->options = $options;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Platform\File\V1\Common\FilePagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Platform\File\V1\Common\FilePagination
    {
        return $this->pagination;
    }
}