<?php
namespace Bushelpowered\Api\Platform\Message\V1\Response;
        
class Target 
{
    /** @var null|string $userId The id of the user. Depending on the method of sending the message, this may be null (for example, a global push for a tenant will send to devices without a logged in user).*/
    public ?string $userId = null;
    /** @var \Bushelpowered\Api\Platform\Message\V1\Response\IdentifierType $identifierType */
    public \Bushelpowered\Api\Platform\Message\V1\Response\IdentifierType $identifierType;
    /** @var \Bushelpowered\Api\Iam\Keycloak\V1\Model\UserIdentifierStandard $identifier */
    public \Bushelpowered\Api\Iam\Keycloak\V1\Model\UserIdentifierStandard $identifier;

    /**
     * @param  null|string  $userId The id of the user. Depending on the method of sending the message, this may be null (for example, a global push for a tenant will send to devices without a logged in user).
     * @param  \Bushelpowered\Api\Platform\Message\V1\Response\IdentifierType  $identifierType 
     * @param  \Bushelpowered\Api\Iam\Keycloak\V1\Model\UserIdentifierStandard  $identifier 
     */
    public function __construct(?string $userId, \Bushelpowered\Api\Platform\Message\V1\Response\IdentifierType $identifierType, \Bushelpowered\Api\Iam\Keycloak\V1\Model\UserIdentifierStandard $identifier)
    {
        $this->userId = $userId;
        $this->identifierType = $identifierType;
        $this->identifier = $identifier;
    }
    

}