<?php
namespace Bushelpowered\Api\Platform\User\V1\Model;
        
class StaffUserIdentifier implements \Bushelpowered\Api\Common\HasTimestamps
{
    /** @var string $id The unique identifier for the staff user's identifier record*/
    public string $id;
    /** @var string $idpSlug The slug of the identity provider (IdP) for this identifier*/
    public string $idpSlug;
    /** @var string $userIdpId The unique value used to recognize a user in an external system*/
    public string $userIdpId;
    /** @var null|\Bushelpowered\Api\Platform\User\V1\Model\IdentifierType $identifierType */
    public ?\Bushelpowered\Api\Platform\User\V1\Model\IdentifierType $identifierType = null;
    /** @var null|string $identifierIntegrationId The identifier integration id, combination of idpSlug and userIdpId to form an unique value*/
    public ?string $identifierIntegrationId = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  string  $id The unique identifier for the staff user's identifier record
     * @param  string  $idpSlug The slug of the identity provider (IdP) for this identifier
     * @param  string  $userIdpId The unique value used to recognize a user in an external system
     * @param  null|\Bushelpowered\Api\Platform\User\V1\Model\IdentifierType  $identifierType 
     * @param  null|string  $identifierIntegrationId The identifier integration id, combination of idpSlug and userIdpId to form an unique value
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $idpSlug, string $userIdpId, ?\Bushelpowered\Api\Platform\User\V1\Model\IdentifierType $identifierType, ?string $identifierIntegrationId, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->id = $id;
        $this->idpSlug = $idpSlug;
        $this->userIdpId = $userIdpId;
        $this->identifierType = $identifierType;
        $this->identifierIntegrationId = $identifierIntegrationId;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}