<?php
namespace Bushelpowered\Api\Quoting\V1\Response;
        
class LineItemResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp, \Bushelpowered\Api\Common\HasCreatedBy, \Bushelpowered\Api\Common\HasUpdatedBy
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var \Bushelpowered\Api\Quoting\V1\Enums\ProductCategory $category */
    public \Bushelpowered\Api\Quoting\V1\Enums\ProductCategory $category;
    /** @var string $productId The UUID of the product*/
    public string $productId;
    /** @var string $productName The name of the product*/
    public string $productName;
    /** @var null|int $quantity The quantity of the product*/
    public ?int $quantity = null;
    /** @var null|string $uom The unit of measure for the quantity*/
    public ?string $uom = null;
    /** @var null|float $price The price of the product*/
    public ?float $price = null;
    /** @var null|float $total The total price of the line item*/
    public ?float $total = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var string $createdBy Created by UUID within the microservice.*/
    public string $createdBy;
    /** @var string $updatedBy Updated by UUID within the microservice.*/
    public string $updatedBy;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  \Bushelpowered\Api\Quoting\V1\Enums\ProductCategory  $category 
     * @param  string  $productId The UUID of the product
     * @param  string  $productName The name of the product
     * @param  null|int  $quantity The quantity of the product
     * @param  null|string  $uom The unit of measure for the quantity
     * @param  null|float  $price The price of the product
     * @param  null|float  $total The total price of the line item
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdBy Created by UUID within the microservice.
     * @param  string  $updatedBy Updated by UUID within the microservice.
     */
    public function __construct(string $id, \Bushelpowered\Api\Quoting\V1\Enums\ProductCategory $category, string $productId, string $productName, ?int $quantity, ?string $uom, ?float $price, ?float $total, string $createdAt, string $updatedAt, string $createdBy, string $updatedBy)
    {
        $this->id = $id;
        $this->category = $category;
        $this->productId = $productId;
        $this->productName = $productName;
        $this->quantity = $quantity;
        $this->uom = $uom;
        $this->price = $price;
        $this->total = $total;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->createdBy = $createdBy;
        $this->updatedBy = $updatedBy;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return string Created by UUID within the microservice.
     */
    public function getCreatedBy(): string
    {
        return $this->createdBy;
    }
    /**
     * @return string Updated by UUID within the microservice.
     */
    public function getUpdatedBy(): string
    {
        return $this->updatedBy;
    }
}